/**
 * WebPM Report Mgr Servlet
 * mharris, censign
 *
 * TODO:
 *
 * database accesses are carried out under the DB username/password pair "mike"/"webpm",
 *  these defaults should be changed according to site policy.
 *
 */

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Map; 
import java.sql.Date; 
import java.util.HashMap;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet; 
import java.sql.Statement; 
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.jasperreports.engine.JREmptyDataSource;
import net.sf.jasperreports.engine.JRResultSetDataSource;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JasperRunManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperPrintManager;
import net.sf.jasperreports.engine.JasperFillManager;

public class reportMgr extends HttpServlet
{

  protected void doGet(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException
  {
    ServletOutputStream servletOutputStream = response.getOutputStream ();
		HashMap<String, Date> params = new HashMap<String, Date> (); 

		String reportReq = request.getParameter ("report"); 
		String query = ""; 

		File reportFile = null;

		Date start = new Date (0, 0, 0);
		Date end = new Date (0, 0, 0);

		if (reportReq.equals ("initiationPlan")) { 

    	reportFile = new File(getServletConfig().getServletContext()
				.getRealPath ("reports/Initiation.jasper")); 

			params = new HashMap<String, Date> (); 

			int ys = Integer.parseInt (request.getParameter ("ys"));
			ys -= 1900; 
			int ms = Integer.parseInt (request.getParameter ("ms")); 
			int ds = Integer.parseInt (request.getParameter ("ds")); 

			int ye = Integer.parseInt (request.getParameter ("ye")); 
			ye -= 1900; 
			int me = Integer.parseInt (request.getParameter ("me")); 
			int de = Integer.parseInt (request.getParameter ("de")); 

			start = new Date (ys, ms, ds); 
			end = new Date (ye, me, de);  

			params.put ("Start Date", start); 
			params.put ("End Date", end); 

			// yeah, buddy.. 
			query = "select *, 1 as sort_col from projects p, assignments a where (pr_start_date >= '" + start + "' AND pr_end_date <= '" + end + "' AND p.pr_number = a.pr_number) UNION select *, 2 from projects p, assignments a where (pr_start_date < '" + start + "' AND pr_end_date <= '" + end + "' AND pr_end_date >= '" + start + "' AND p.pr_number = a.pr_number) UNION select *, 3 from projects p, assignments a where (pr_start_date < '" + start + "' AND pr_end_date > '" + end + "' AND  p.pr_number = a.pr_number) UNION select *, 4 from projects p, assignments a where (pr_start_date >= '" + start + "' AND pr_start_date <= '" + end + "' AND pr_end_date > '" + end + "' AND p.pr_number = a.pr_number) Order by sort_col;";

		} else if (reportReq.equals ("roadmap")) { 

    	reportFile = new File(getServletConfig().getServletContext()
				.getRealPath ("reports/Roadmap.jasper")); 

			query = "select * from business_cases b, projects p where b.BC_NUMBER = p.BC_NUMBER;"; 

		} else if (reportReq.equals ("timeline")) { 

    	reportFile = new File(getServletConfig().getServletContext()
				.getRealPath ("reports/Timeline.jasper")); 

		} 

    byte[] bytes = null;

    try
    { 

			Connection con; 
			con = DriverManager.getConnection ("jdbc:mysql://webpm/webpm", "mike", "webpm"); 
			Statement s = con.createStatement (); 
			ResultSet rs = s.executeQuery (query); 

			String p = reportFile.getPath (); 

			JRResultSetDataSource d = new JRResultSetDataSource (rs); 
      bytes = JasperRunManager.runReportToPdf (p, params, d); 

      response.setContentType("application/pdf"); 
      response.setContentLength(bytes.length);

      servletOutputStream.write(bytes, 0, bytes.length);
      servletOutputStream.flush();
      servletOutputStream.close(); 

    } catch (Exception e) { 

      StringWriter stringWriter = new StringWriter();
      PrintWriter printWriter = new PrintWriter(stringWriter);
      e.printStackTrace(printWriter);
      response.setContentType("text/plain");
      response.getOutputStream().print(stringWriter.toString());

    } 
  }
}

