import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.security.Principal;
import java.sql.Connection; 
import java.sql.DriverManager; 
import java.sql.ResultSet; 
import java.sql.Statement; 
import java.sql.SQLException;
import com.mysql.jdbc.ResultSetMetaData;
import org.json.JSONArray; 
import org.json.JSONException;
import org.json.JSONObject; 

public class treeDataProvider extends javax.servlet.http.HttpServlet 
	implements javax.servlet.Servlet
{
	private Connection con; 
	private String constructorResponse = ""; 

	public treeDataProvider () { 
		super (); 
	}

	private void setupDb (HttpServletRequest r) { 
		String url = "jdbc:mysql://webpm/webpm"; 
		// replace w/Auth object (meh) 

		/* Principal p = r.getUserPrincipal (); 
		if (p != null) { 
			globalWrite ("username: " + p.getName ()); 
			globalWrite ("is webpmAdmin: " + r.isUserInRole ("webpmAdmin")); 
		} */

		String user = "mike"; 
		String password = "webpm"; 

	  try {
      Class.forName ("com.mysql.jdbc.Driver");
      con  =  DriverManager.getConnection (url, user, password);
		} catch (Exception e) { 
			e.printStackTrace (); 
		}

	}

	protected void doDelete (HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException
	{
		setupDb (request); 

		response.setContentType ("text/plain"); 

		String requestId = request.getPathInfo ().substring (1); 
		String[] queries = new String [3]; 

		if (requestId.substring(0,2).equals ("bc")) { 

			queries [0] = "DELETE FROM assignments WHERE pr_number IN (SELECT pr_number FROM projects WHERE bc_number = '" + requestId + "');"; 
			queries [1] = "DELETE FROM amounts WHERE pr_number IN (SELECT pr_number FROM projects WHERE bc_number = '" + requestId + "');";
			queries [2] = "DELETE FROM projects WHERE bc_number = '" + requestId + "';"; 
			queries [3] = "DELETE FROM business_cases WHERE bc_number = '" + requestId + "';"; 

		} else if (requestId.substring(0,2).equals ("pr")) { 

			queries [0] = "DELETE FROM assignments WHERE pr_number = '" + requestId + "';"; 
			queries [1] = "DELETE FROM amounts WHERE pr_number = '" + requestId + "';"; 
			queries [2] = "DELETE FROM projects WHERE pr_number = '" + requestId + "';"; 
			queries [3] = "DELETE FROM resources WHERE re_number NOT IN (SELECT re_number FROM assignments);";  

		} else if (requestId.substring(0,2).equals ("re")) {

			queries [0] = "DELETE FROM assignments WHERE re_number = '" + requestId + "';"; 
			queries [1] = "DELETE FROM resources WHERE re_number = '" + requestId + "';"; 

		} 

		for (String query : queries) { 
			if (query != null && ! query.equals ("")) { 
				try { 
					Statement s; 
					s = con.createStatement (); 
					s.executeUpdate (query); 
				} catch (Exception e) { 
					response.getWriter ().write ("database updated failed: " + query); 
				} 
			} 
		} 

		response.getWriter ().flush ();
		response.getWriter ().close (); 
	} 

	protected void doGet (HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException
	{
		doPost (request, response); 
	} 

	protected void doPut (HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException
	{
		setupDb (request); 

		response.setContentType ("text/plain"); 

		String requestId = request.getPathInfo ().substring (1); 

		if (requestId.equals ("")) { 
			return; 
		} 

		/* JSONArray treeData = buildBranch (requestId); 
		response.getWriter ().write (treeData.toString ()); 	
		response.getWriter ().flush ();
		response.getWriter ().close (); */ 

	} 

	private HttpServletResponse globalResponse = null; 
	private void setGlobalResponse (HttpServletResponse r) { globalResponse = r; } 
	private void globalWrite (String s) { 
		if (globalResponse != null) { 
			try { globalResponse.getWriter ().write (s); } catch (IOException neverMind) { } 
		} 
	}

	protected void doPost (HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException
	{	
		setGlobalResponse (response); 
		setupDb (request); 

		response.setContentType ("text/plain"); 

		String requestId = request.getPathInfo ().substring (1); 

		if (requestId.equals ("")) { 
			return; 
		} 

		if (requestId.equals ("root")) {
			JSONArray treeData = buildBranch (requestId); 
			response.getWriter ().write (treeData.toString ()); 
		} else {
			JSONObject treeObject = buildItem (requestId); 
			response.getWriter ().write (treeObject.toString ()); 
		} 

		response.getWriter ().flush ();
		response.getWriter ().close (); 
	} 

	private JSONArray buildBranch (String requestId) 
	{
		String numAttr = "", nameAttr = ""; 

		JSONArray thisBranch = new JSONArray (); 
		String query = ""; 

		if (requestId.equals ("root")) {

			/* query = "SELECT bc_number,bc_name FROM business_cases;"; 
			numAttr = "BC_NUMBER"; 
			nameAttr = "BC_NAME"; */ 
			try { 
				thisBranch.put (new root ("business_cases", "Business Cases")); 
				//thisBranch.put (new root ("free_resources", "Free Resources")); 
			} catch (Exception e) { e.printStackTrace (); } 
			return thisBranch; 

		} else if (requestId.equals ("business_cases")) { 

			query = "SELECT bc_number,bc_name FROM business_cases;"; 
			numAttr = "BC_NUMBER"; 
			nameAttr = "BC_NAME"; 

		} /* else if (requestId.equals ("free_resources")) { 

			query = "SELECT re_number,re_name FROM resources WHERE re_number NOT IN (SELECT re_number FROM assignments);"; 
			numAttr = "RE_NUMBER"; 
			nameAttr = "RE_NAME"; 

		} */ else if (requestId.substring(0,2).equals ("bc")) { 

			query = "SELECT pr_number,pr_name FROM projects WHERE bc_number = '" + requestId + "';"; 
			numAttr = "PR_NUMBER"; 
			nameAttr = "PR_NAME"; 

		} else if (requestId.substring(0,2).equals ("pr")) { 

			query = "SELECT re_number,re_name FROM resources WHERE re_number in (SELECT re_number FROM assignments WHERE pr_number = '" + requestId + "');"; 
			numAttr = "RE_NUMBER"; 
			nameAttr = "RE_NAME"; 

		} 

		if (! query.equals ("")) { 

		Statement s; 

		try { 
			s = con.createStatement (); 
     	ResultSet rs = s.executeQuery (query);
     	ResultSetMetaData rsmd = (ResultSetMetaData) rs.getMetaData ();

			while (rs.next ()) {
				thisBranch.put (new branch (rs.getString (numAttr), rs.getString (nameAttr))); 	
			} 
		
			s.close (); 

		} catch (SQLException e) { 
			globalWrite ("SQL Exception: " + e.getMessage ()); 
			e.printStackTrace (); 
		} 

		} // ! query.equals ("")

		return thisBranch; 
	}

	private JSONObject buildItem (String requestId) 
	{
		JSONObject thisItem = new JSONObject (); 

		try { 
			thisItem.put ("id", requestId); 
			if (requestId.equals ("business_cases"))
				thisItem.put ("label", "Business Cases"); 
			/* else if (requestId.equals ("free_resources"))
				thisItem.put ("label", "Free Resources"); */ 
			else {

				String nameTable = "";
				String nameAttr = "";
				String idAttr = ""; 

				if (requestId.substring (0,2).equals ("bc")) {
					nameTable = "business_cases"; 
					nameAttr = "BC_NAME"; 
					idAttr = "BC_NUMBER"; 
				} else if (requestId.substring (0,2).equals ("pr")) { 
					nameTable = "projects"; 
					nameAttr = "PR_NAME"; 
					idAttr = "PR_NUMBER"; 
				} else if (requestId.substring (0,2).equals ("re")) { 
					nameTable = "resources"; 
					nameAttr = "RE_NAME"; 
					idAttr = "RE_NUMBER"; 
				} 

				try { 
					Statement s = con.createStatement (); 
					ResultSet rs = s.executeQuery ("SELECT " + nameAttr + " FROM " + nameTable + " WHERE " + idAttr + " = '" + requestId + "';"); 

					rs.next (); 

					thisItem.put ("label", rs.getString (nameAttr)); 
				} catch (Exception e) { 
					e.printStackTrace (); 
				} 

			} 

			JSONArray b = buildBranch (requestId); 
			thisItem.put ("folders", b); 

		} catch (JSONException e) { 
			e.printStackTrace (); 
		} 

		return thisItem; 
	}

	class root extends JSONObject 
	{
		String ref, id;

		root (String r, String n) { 
			super (); 

			ref = r; 
			id = n; 

			try { 
				this.put ("$ref", ref); 
				this.put ("id", ref); 
				this.put ("label", id); 
				this.put ("folders", "true"); 
			} catch (JSONException e) { 
				e.printStackTrace (); 
			} 
		} 
	} 

	class branch extends JSONObject 
	{ 
		String ref, id;

		branch (String r, String n) { 
			super (); 

			ref = r; 
			id = n; 

			try { 
				this.put ("$ref", ref); 
				this.put ("id", ref); 
				this.put ("label", id); 
				if (hasChildren ()) 
					this.put ("folders", "true"); 
			} catch (JSONException e) { 
				e.printStackTrace (); 
			} 
		} 
		boolean hasChildren () 
		{ 
			String query = ""; 

			if (ref.equals ("root")) 
				query = "SELECT * FROM business_cases WHERE bc_number = '" + ref + "';"; 
			else if (ref.substring (0,2).equals ("bc")) 
				query = "SELECT * FROM projects WHERE bc_number = '" + ref + "';"; 
			else if (ref.substring (0,2).equals ("pr")) {
				//query = "SELECT * FROM resources WHERE pr_number = '" + ref + "';"; 
				query = "SELECT * FROM resources WHERE re_number in (SELECT re_number FROM assignments WHERE pr_number = '" + ref + "');"; 
			} 

			if (query != "") { 

			try { 
				Statement s = con.createStatement (); 
				ResultSet rs = s.executeQuery (query); 

				rs.next (); 

				if (rs.getRow () == 1) 
					return true; 
			} catch (Exception e) { 
				e.printStackTrace (); 
			} 

			} 

			return false; 
		}

	} // branch 

} // treeDataProvider 

