<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
	"http://www.w3.org/TR/html4/strict.dtd">

<!-- Notes:

  --> 

<html>

<!-- header { --> 
<head>
	<title>WebPM Login</title>
	<link rel="stylesheet" href="css/index.css"> 
	<script type="text/javascript" src="js/dojo/dojo.js" charset="utf-8"></script> 
	<script type="text/javascript" src="js/login.js" charset="utf-8"></script> 
</head>
<!-- } --> 

<body class="soria"> 

	<div id="preLoader"><p></p></div>

	<!-- main { --> 
	<div dojoType="dijit.layout.BorderContainer" gutters="true" id="main">
		<div dojoType="dijit.layout.ContentPane" region="center">

			<blockquote>

			<h1>WebPM v.1.0.0</h1> <br> 

			By The WebPM Project Team: <br>
			&nbsp; &nbsp; Chris Ensign, Ryan Laporte, and Michael Harris <br>
			Under the supervsion of Kenny Fong, Southern Illinois University, 2010. <br>
			Prepared for: State Farm of Bloomington, IL.  Copyright (C) 2010.  All rights reserved. <br>

			<br> 

			<button
				id="login" dojoType="dijit.form.Button"
				iconClass="webpmIconRequestLogin"> 
				Login to WebPM
				<script type="dojo/method" event="onClick">
					dijit.byId('login_dialog').show (); 
				</script> 
			</button> 

			<button
				id="no_thanks" dojoType="dijit.form.Button"
				iconClass="webpmIconLoginNoThanks"> 
				No thanks
				<script type="dojo/method" event="onClick">
					dijit.byId('login_dialog').show (); 
				</script> 
			</button> 

			</blockquote> 

		</div> <!-- contentpane --> 
	</div>  <-- bordercontainer --> 
	<!-- } --> 

</body> 

<!-- login_dialog { --> 
<div dojoType="dijit.Dialog" id="login_dialog" title="WebPM Login"> 

	<form method="POST" 
		action='<%= response.encodeURL("j_security_check") %>'> 

	<table border=1 align="center" class="loginTable"> 	
  	<tr><td><img src="img/webpm_logo.png"></td></tr>
		<tr> 
			<td> 
				Login: 
					<input type="text" dojoType="dijit.form.TextBox"
						 name="j_username"
             id="j_username"
             value=""
             required="true" 
             style="width: 20em;" />
			</td>
		</tr>
		<tr>
			<td> 
         Password: 
           <input type="password" dojoType="dijit.form.TextBox" 
						 name="j_password" 
             id="j_password"
             required="true" 
						 style="width: 20em;" />
			</td>
		</tr> 
		<tr>
			<td>
				<button dojoType="dijit.form.Button" type="submit" iconClass="webpmIconLoginGo"> 
					Login
				</button> 

				<button dojoType="dijit.form.Button" iconClass="webpmIconLoginDismiss"> 
					Dismiss
					<script type="dojo/method" event="onClick"> 
						dijit.byId('login_dialog').hide (); 
					</script> 
				</button> 
			</td> 
		</tr> 
  	<tr><td><a href="help.html">Trouble getting this blasted thing to work?</a></td></tr>
	</table> 

	</form> 

</div> <!-- dialog --> 
<!-- } --> 

</html>

