/**
 * WebPM Data class defn 
 * mharris, censign
 *
 * All webpm data objects derive from this class, the purpose of which is currently 
 * restricted to validation.  It can/should be expanded to incorporate SF business 
 * rules as necessary. 
 */

import java.util.regex.Pattern; 
import java.util.regex.Matcher; 

class webpmData 
{
	protected boolean isAlphaNumeric (String data)
  {
  	Pattern pattern = Pattern.compile ("\\W+");
    Matcher matcher;

    matcher = pattern.matcher (data);
    if (matcher.find ()) 
    	return false;

    return true;
	}

	protected boolean isNumeric (String data) 
	{
		Pattern pattern = Pattern.compile ("\\D+"); 
		Matcher matcher; 

		matcher = pattern.matcher (data); 
		if (matcher.find ())
			return false; 

		return true; 
	} 

	protected boolean noRestrictedCharacters (String data)
  {
    if (
			data.contains("<") ||
			data.contains(">") ||
			data.contains(";") ||
      data.contains("'") ||
			data.contains("\"")) 
    {
      return false;
    }

    return true;
  }
}

