<html>

<!-- header { --> 
<head>
	<title>WebPM</title>
	<link rel="stylesheet" href="css/index.css"> 
	<script type="text/javascript" src="js/dojo/dojo.js" charset="utf-8"></script> 
	<script type="text/javascript" src="js/src.js" charset="utf-8"></script> 
	<script type="text/javascript" src="js/prm_form.js" charset="utf-8"></script> 
	<script type="text/javascript" src="js/bcm_form.js" charset="utf-8"></script> 
	<script type="text/javascript" src="js/rem_form.js" charset="utf-8"></script> 
	<!-- <script type="text/javascript" src="js/usm_form.js" charset="utf-8"></script> --> 
	<!-- <script type="text/javascript" src="js/ser_form.js" charset="utf-8"></script> --> 
</head>
<!-- } --> 

<body class="soria" role="application">
	<div id="preLoader"><p></p></div>

	<!-- init. data stores { --> 

	<div dojoType="dojo.data.ItemFileWriteStore"
			jsId="users_data"
			url="json/users_data.json"></div>

	<div dojoType="dojo.data.ItemFileWriteStore"
			jsId="bc_name_store" 
			url="http://webpm:8080/webpm/businessCaseMgr?q=get_name_store"
			urlPreventCache="true" 
			clearOnClose="true"></div> 

	<div dojoType="dojo.data.ItemFileWriteStore"
			jsId="pr_name_store" 
			url="http://webpm:8080/webpm/projectMgr?q=get_name_store" 
			urlPreventCache="true" 
			clearOnClose="true"></div> 

	<div dojoType="dojo.data.ItemFileWriteStore"
			jsId="re_name_store" 
			url="http://webpm:8080/webpm/resourceMgr?q=get_name_store" 
			urlPreventCache="true" 
			clearOnClose="true"></div> 

	<div dojoType="dojo.data.ItemFileWriteStore"
			jsId="status_store" 
			url="http://webpm:8080/webpm/projectMgr?q=get_status_store" 
			urlPreventCache="true" 
			clearOnClose="true"></div>  

	<!-- } --> 

<!-- widget declarations --> 

	<!-- webpm.LoadUser { -->
	<div dojoType="dijit.Declaration"
		widgetClass="webpm.LoadUser" defaults="{ id: 0 }">

		<div dojoType="dijit.layout.BorderContainer"
				dojoAttachPoint="container"
				closeable="true">

			<div dojoType="dijit.layout.ContentPane"
					region="top"
					style="height:26px; z-index: 10; color:#666;"> 

			    <table width="100%">
				</table>

			</div>
		</div>
	</div> 
	<!-- } --> 

	<!-- webpm.LoadSearchResults { -->
	<div dojoType="dijit.Declaration"
		widgetClass="webpm.LoadSearchResults">

		<div dojoType="dijit.layout.BorderContainer"
			dojoAttachPoint="container"
			closeable="true">

			<div dojoType="dijit.layout.ContentPane"
				region="top"
				style="z-index: 10;"> <!-- height: 26px; --> 

				<table>
				</table>

			</div> <!-- contentpane --> 
		</div> <!-- bordercontainer --> 
	</div> <!-- declaration --> 
	<!-- } --> 

<!-- dialog boxes --> 

  <!-- edit_bc_dialog { --> 
	<div dojoType="dijit.Dialog" id="edit_bc_dialog" title="Edit Business Case"> 

		<div dojoType="dijit.form.Form"
			id="edit_bc_form"
			jsId="edit_bc_form"
			encType="multipart/form-data"
			action="http://webpm:8080/webpm/businessCaseMgr"> 

		<table>

			<tr> 
				<td> 
					Name
						<input type="text" dojoType="dijit.form.TextBox"
							 name="edit_bc_name"
               id="edit_bc_name"
               value=""
               required="true" 
               style="width: 20em;" />
          Number: 
            <input type="text" dojoType="dijit.form.ValidationTextBox" 
							 name="edit_bc_number" 
               id="edit_bc_number"
               regExp="bc\d{4}"
               required="true" 
							 readonly 
               invalidMessage="Invalid business case number." />
				</td>
			</tr> 

			<tr><td>Business Case Description</td></tr> 

			<tr>
       	<td>
					<textarea id="edit_bc_desc"
							name="edit_bc_desc"
							dojoType="dijit.form.SimpleTextarea"
        			rows="4"
							style="width: 100%;"
							value=" ">
        	</textarea>
				</td> 
			</tr> 

			<tr>
				<td align="center"> 
        	<button dojoType="dijit.form.Button" iconClass="webpmIconOk" id="edit_bc_submit" type="reset"> 
          	Save
						<script type="dojo/method" event="onClick" args="evt">

							evt.preventDefault();
							evt.stopPropagation();


							// validation 
							/* if (! dijit.byId('edit_bc_name').isValid ()) {
								; alert('invalid bc name'); 
							} else */ if (! dijit.byId('edit_bc_number').isValid ()) {
								; alert('invalid bc number'); 
							} else { 

							var thisNumber = dijit.byId ('edit_bc_number').attr ('value'); 
							var thisName = dijit.byId ('edit_bc_name').attr ('value'); 

							var xhrArgs = {
								form: dojo.byId ("edit_bc_form"),

								url: "http://webpm:8080/webpm/businessCaseMgr", 
								handleAs: "text",
								load: function (data) {
									modifyBusinessCase (thisNumber, thisName); 
								},
								error: function(error, ioargs) {
									//dojo.byId("home_container").innerHTML = "Error from server: " + error + " status: " + ioargs.xhr.status;
								}
							};

  						var deferred = dojo.xhrPost(xhrArgs);

							dijit.byId ('edit_bc_dialog').hide (); 

							dojo.byId ('edit_bc_name').value = ''; 
							dojo.byId ('edit_bc_number').value = ''; 
							dojo.byId ('edit_bc_desc').value = ''; 

							} 
						</script> 
          </button>
					<button dojoType="dijit.form.Button"
						type="reset"
						iconClass="webpmIconCancel"
						onClick="dijit.byId ('edit_bc_dialog').hide ();">
						Cancel
					</button> 
        </td> 
			</tr> 

		</table> 

		</div> <!-- form --> 

	</div> 
	<!-- } --> 

	<!-- new_bc_dialog { --> 
	<div dojoType="dijit.Dialog" id="new_bc_dialog" title="Add Business Case"> 

		<div dojoType="dijit.form.Form"
			id="new_bc_form"
			jsId="new_bc_form"
			encType="multipart/form-data"
			action="http://webpm:8080/webpm/businessCaseMgr"> 

		<table width="100%;" style="border: 1px solid #8ba0bd;padding: 0px;border-collapse: collapse;"> 
			<tr><td style="background-color: #8ba0bd"><b>Business Case Properties:</b></td></tr>
      <tr><td>

		<table width="100%;" cellspacing="10">
			<tr> 
				<td> 
					Name
						<input type="text" dojoType="dijit.form.TextBox"
							 name="new_bc_name"
               id="new_bc_name"
               value=""
               required="true" 
               style="width: 20em;" />
          Number: 
            <input type="text" dojoType="dijit.form.ValidationTextBox" 
							 name="new_bc_number" 
               id="new_bc_number"
               regExp="bc\d{4}"
               required="true" 
               invalidMessage="Invalid business case number." />
				</td>
			</tr> 
		</table></td></tr> 

		<tr><td style="background-color: #8ba0bd;" width="100%;"><b>Business Case Description</b></td></tr> 

		<tr><td> 
		<table width="100%;" cellspacing="10"> 
			<tr>
       	<td>
					<textarea id="new_bc_desc"
							name="new_bc_desc"
							dojoType="dijit.form.SimpleTextarea"
        			rows="4"
							style="width: 100%;"
							value=" ">
        	</textarea>
				</td> 
			</tr> 

			<tr>
				<td align="center"> 
        	<button dojoType="dijit.form.Button" iconClass="webpmIconOk" id="new_bc_submit" type="reset"> 
          	Save
						<script type="dojo/method" event="onClick" args="evt">

							evt.preventDefault();
							evt.stopPropagation();

							// validation 
							/* if (! dijit.byId('new_bc_name').isValid ()) {
								; alert('invalid bc name'); 
							} else */ if (! dijit.byId('new_bc_number').isValid ()) {
								; alert('invalid bc number'); 
							} else { 

							var thisNumber = dijit.byId ('new_bc_number').attr ('value'); 
							var thisName = dijit.byId ('new_bc_name').attr ('value'); 
							addBusinessCase (thisNumber, thisName); 

							dijit.byId ('new_bc_dialog').hide (); 
							dojo.byId ('new_bc_name').value = ''; 
							dojo.byId ('new_bc_number').value = ''; 
							dojo.byId ('new_bc_desc').value = ''; 

							} 
						</script> 
          </button>
					<button dojoType="dijit.form.Button"
						type="reset"
						iconClass="webpmIconCancel"
						onClick="dijit.byId ('new_bc_dialog').hide ();">
						Cancel
					</button> 
        </td> 
			</tr> 

		</table> 
		</table> 

		</div> <!-- form --> 

	</div> 
	<!-- } --> 

	<!-- new_pr_dialog { --> 
	<div dojoType="dijit.Dialog" id="new_pr_dialog" title="Add Project"> 

		<div dojoType="dijit.form.Form"
			id="new_pr_form"
			jsId="new_pr_form"
			encType="multipart/form-data"
			action="http://webpm:8080/webpm/projectMgr"> 

		<div id="new_pr_amounts_by_year">
		</div> 

		<div id="new_pr_resource_hours_allocd">
		</div> 

		<table width="100%;" style="border: 1px solid #8ba0bd;border-collapse: collapse;" cellspacing="10" cellpadding="10"> 
      <tr><td style="background-color: #8ba0bd"><b>Project Properties:</b></td></tr>

      <tr><td>

		<table cellspacing="10" cellpadding="10">
			<tr> <!-- name --> 
		 		<td align=right>
					Name
				</td> 
				<td colspan="2"> 
        	<input type="text" dojoType="dijit.form.TextBox"
             id="new_pr_name"
						 name="new_pr_name" 
             required="true" 
             style="width: 100%;" /> 
				</td> 
			</tr> 

			<tr> <!-- number --> 
		 		<td align=right>
          Number: 
				</td> 
				<td colspan="2"> 
          <input type="text" dojoType="dijit.form.ValidationTextBox" 
             id="new_pr_number"
						 name="new_pr_number" 
             regExp="pr\d{4}"
             required="true" 
             invalidMessage="Invalid project number."
             style="width: 100%;" /> 
				</td> 
			</tr> 

			<tr> <!-- business case --> 
		 		<td align=right>
					Business Case
				</td>
				<td colspan="2"> 
					<select dojoType="dijit.form.FilteringSelect" id="new_pr_business_case"
						name="new_pr_business_case"
						store="bc_name_store"
						searchAttr="bc_number"
						style="width: 100%;">
        	</select>
				</td> 
			</tr> 

			<tr> <!-- project mgr. --> 
		 		<td align=right>
					Project Manager
				</td> 
				<td colspan="2"> 
					<select dojoType="dijit.form.FilteringSelect" id="new_pr_mgr"
						name="new_pr_mgr"
						store="re_name_store"
						searchAttr="re_name"
						style="width: 100%;">
        	</select>
				</td> 
			</tr> 

			<tr> <!-- project poc --> 
		 		<td align=right>
					POC
				</td>
				<td colspan="2"> 
					<select dojoType="dijit.form.FilteringSelect" id="new_pr_poc"
						name="new_pr_poc"
						store="re_name_store"
						searchAttr="re_name"
						style="width: 100%;">
        	</select>
				</td> 
			</tr> 

			<tr> <!-- sponsor --> 
		 		<td align=right>
					Sponsor
				</td> 
				<td colspan="2">
					<select dojoType="dijit.form.FilteringSelect" id="new_pr_sponsor"
						name="new_pr_sponsor"
						store="bc_name_store"
						searchAttr="bc_number"
						style="width: 100%;">
        	</select>
				</td> 
			</tr> 

			<tr> <!-- sponsoring component --> 
		 		<td align=right>
					Sponsoring Component
				</td> 
				<td colspan="2">
					<select dojoType="dijit.form.FilteringSelect" id="new_pr_sponsoring_component"
						name="new_pr_sponsoring_component"
						store="bc_name_store"
						searchAttr="bc_number"
						style="width: 100%;">
        	</select>
				</td> 
			</tr> 

			<tr> <!-- start date --> 
		 		<td align=right>
					Start Date
				</td> 
				<td colspan="2"> 
					<input type="text"
						name="new_pr_start_date"
						id="new_pr_start_date"
						value=""
						dojoType="dijit.form.DateTextBox"
        		required="true"
						style="width: 100%;" />
				</td> 
			</tr> 

			<tr> 
		 		<td align=right>
					End Date
				</td> 
				<td colspan="2">
					<input type="text"
						name="new_pr_end_date"
						id="new_pr_end_date"
						value=""
						dojoType="dijit.form.DateTextBox"
        		required="true"
						style="width: 100%;"/>
				</td> 
			</tr> 

			<tr> <!-- project status --> 
		 		<td align=right>
					Status
				</td> 
				<td colspan="2"> 
					<select dojoType="dijit.form.FilteringSelect"
						id="new_pr_status"
						name="new_pr_status"
						store="status_store"
						searchAttr="st_name"
						style="width: 100%;">
        	</select>
				</td> 
			</tr> 

			<tr> <!-- amount --> 
		 		<td align=right>
					Amount
				</td> 
				<td> 
   				<input type="text"
						name="new_pr_amount" id="new_pr_amount"
						dojoType="dijit.form.CurrencyTextBox"
        		required="true"
						constraints="{fractional:true}"
						currency="USD"
						invalidMessage="Invalid amount.  Cents are required."
						readonly />
				</td> 
				<td align="right"> 
					<button dojoType="dijit.form.Button">
						...
						<script type="dojo/method" event="onClick">
							dijit.byId ('pr_amount_year').attr ('value', (new Date ()).getFullYear ()); 
							dijit.byId ('pr_amount_dialog').show();
						</script> 
					</button> 
				</td>
			</tr> 

			<tr> <!-- resources --> 
		 		<td align=right>
					Resource Hours
				</td> 
				<td> 
   					<input type="text"
							name="new_pr_resource_hours"
							id="new_pr_resource_hours"
							dojoType="dijit.form.NumberTextBox"
        			required="true" 
							readonly />
				</td> 
				<td> 
					<button dojoType="dijit.form.Button">
						...
						<script type="dojo/method" event="onClick">
							dijit.byId('re_alloc_dialog').show();
						</script> 
					</button>
				</td>
			</tr> 
		</table></td></tr> 

		<tr><td style="background-color: #8ba0bd;" width="100%;"><b>Project Description</b></td></tr>

		<tr><td>
		<table cellspacing="10" cellpadding="10" width="100%;">
			<tr> <!-- description (input field) --> 
       	<td colspan="3">
					<textarea id="new_pr_desc"
						name="new_pr_desc"
						dojoType="dijit.form.SimpleTextarea"
        		rows="4" style="width: 100%;"
						value=" ">
        	</textarea>
				</td> 
			</tr> 
		</table> 
		</td></tr>

		<tr><td>
		<table align="center" cellpadding="10" cellspacing="10">
			<tr>
       	<td> 
          <button dojoType="dijit.form.Button" iconClass="webpmIconOk" id="new_pr_submit" type="reset"> 
            Save
						<script type="dojo/method" event="onClick" args="evt">

							evt.stopPropagation();

							// validation 
							/* if (! dijit.byId('new_pr_name').isValid ()) {
								; alert ('invalid new_pr_name'); 
							} else */ if (! dijit.byId('new_pr_number').isValid ()) {
								; alert ('invalid new_pr_number'); 
							} /* else if (! dijit.byId('new_pr_business_case').isValid ()) { 
								; alert ('invalid new_pr_business_case'); 
							} else if (! dijit.byId('new_pr_mgr').isValid ()) { 
								; alert ('invalid new_pr_manager'); 
							} else if (! dijit.byId('new_pr_poc').isValid ()) { 
								; alert ('invalid new_pr_poc'); 
							} else if (! dijit.byId('new_pr_sponsor').isValid ()) {
								; alert ('invalid new_pr_sponsor'); 
							} else if (! dijit.byId('new_pr_start_date').isValid ()) { 
								; alert ('invalid new_pr_start_date'); 
							} else if (! dijit.byId('new_pr_end_date').isValid ()) { 
								; alert ('invalid new_pr_end_date'); 
							} else if (! dijit.byId('new_pr_status').isValid ()) { 
								; alert ('invalid new_pr_status'); 
							} */ else { 

							var targetBc = dijit.byId('new_pr_business_case').attr('value'); 
              var thisNumber = dijit.byId ('new_pr_number').attr ('value');
              var thisName = dijit.byId ('new_pr_name').attr ('value');
              addProject (targetBc, thisNumber, thisName);

              dijit.byId ('new_pr_dialog').hide ();
              dojo.byId ('new_bc_name').value = '';
              dojo.byId ('new_bc_number').value = '';
              dojo.byId ('new_bc_desc').value = '';

							} 
						</script> 
          </button>
					<button dojoType="dijit.form.Button"
						iconClass="webpmIconCancel"
						onClick="dijit.byId ('new_pr_dialog').hide (); project_amounts.revert (); resource_allocs.revert ();"
						type="reset">
						Cancel
					</button> 
        </td> 
			</tr> 
		</table></td></tr>  

		</table> 

		</div> <!-- form --> 

	</div> <!-- dialog --> 
	<!-- } --> 

	<!-- edit_pr_dialog { --> 
	<div dojoType="dijit.Dialog" id="edit_pr_dialog" title="Edit Project"> 

		<div dojoType="dijit.form.Form"
			id="edit_pr_form"
			jsId="edit_pr_form"
			encType="multipart/form-data"
			action="http://webpm:8080/webpm/projectMgr"> 

		<div id="edit_pr_amounts_by_year">
		</div> 

		<div id="edit_pr_resource_hours_allocd">
		</div> 

		<table cellspacing="10" cellpadding="10">
			<tr> <!-- name --> 
		 		<td align=right>
					Name
				</td> 
				<td colspan="2"> 
        	<input type="text" dojoType="dijit.form.TextBox"
             id="edit_pr_name"
						 name="edit_pr_name" 
             required="true" 
             style="width: 100%;" /> 
				</td> 
			</tr> 

			<tr> <!-- number --> 
		 		<td align=right>
          Number: 
				</td> 
				<td colspan="2"> 
          <input type="text" dojoType="dijit.form.ValidationTextBox" 
             id="edit_pr_number"
						 name="edit_pr_number" 
             regExp="pr\d{4}"
             required="true" 
             invalidMessage="Invalid project number."
             style="width: 100%;" /> 
				</td> 
			</tr> 

			<tr> <!-- business case --> 
		 		<td align=right>
					Business Case
				</td>
				<td colspan="2"> 
					<select dojoType="dijit.form.FilteringSelect" id="edit_pr_business_case"
						name="edit_pr_business_case"
						store="bc_name_store"
						searchAttr="bc_number"
						style="width: 100%;">
        	</select>
				</td> 
			</tr> 

			<tr> <!-- project mgr. --> 
		 		<td align=right>
					Project Manager
				</td> 
				<td colspan="2"> 
					<select dojoType="dijit.form.FilteringSelect" id="edit_pr_mgr"
						name="edit_pr_mgr"
						store="re_name_store"
						searchAttr="re_name"
						style="width: 100%;">
        	</select>
				</td> 
			</tr> 

			<tr> <!-- project poc --> 
		 		<td align=right>
					POC
				</td>
				<td colspan="2"> 
					<select dojoType="dijit.form.FilteringSelect" id="edit_pr_poc"
						name="edit_pr_poc"
						store="re_name_store"
						searchAttr="re_name"
						style="width: 100%;">
        	</select>
				</td> 
			</tr> 

			<tr> <!-- sponsor --> 
		 		<td align=right>
					Sponsor
				</td> 
				<td colspan="2">
					<select dojoType="dijit.form.FilteringSelect" id="edit_pr_sponsor"
						name="edit_pr_sponsor"
						store="bc_name_store"
						searchAttr="bc_number"
						style="width: 100%;">
        	</select>
				</td> 
			</tr> 

			<tr> <!-- sponsoring component --> 
		 		<td align=right>
					Component
				</td> 
				<td colspan="2">
					<select dojoType="dijit.form.FilteringSelect" id="edit_pr_sponsoring_component"
						name="edit_pr_sponsoring_component"
						store="bc_name_store"
						searchAttr="bc_number"
						style="width: 100%;">
        	</select>
				</td> 
			</tr> 

			<tr> <!-- start date --> 
		 		<td align=right>
					Start Date
				</td> 
				<td colspan="2"> 
					<input type="text"
						name="edit_pr_start_date"
						id="edit_pr_start_date"
						value=""
						dojoType="dijit.form.DateTextBox"
        		required="true"
						style="width: 100%;" />
				</td> 
			</tr> 

			<tr> <!-- end date --> 
		 		<td align=right>
					End Date
				</td> 
				<td colspan="2"> 
					<input type="text"
						name="edit_pr_end_date"
						id="edit_pr_end_date"
						value=""
						dojoType="dijit.form.DateTextBox"
        		required="true"
						style="width: 100%;"/>
				</td> 
			</tr> 

			<tr> <!-- project status --> 
		 		<td align=right>
					Status
				</td> 
				<td colspan="2"> 
					<select dojoType="dijit.form.FilteringSelect"
						id="edit_pr_status"
						name="edit_pr_status"
						store="status_store"
						searchAttr="st_name"
						style="width: 100%;">
        	</select>
				</td> 
			</tr> 

			<tr> <!-- amount --> 
		 		<td align=right>
					Amount
				</td> 
				<td> 
   				<input type="text"
						name="edit_pr_amount" id="edit_pr_amount"
						dojoType="dijit.form.CurrencyTextBox"
        		required="true"
						constraints="{fractional:true}"
						currency="USD"
						invalidMessage="Invalid amount.  Cents are required."
						readonly />
				</td> 
				<td align="right"> 
					<button dojoType="dijit.form.Button">
						...
						<script type="dojo/method" event="onClick">
							dijit.byId ('pr_amount_year').attr ('value', (new Date ()).getFullYear ()); 
							dijit.byId ('pr_amount_dialog').show();
						</script> 
					</button> 
				</td>
			</tr> 

			<tr> <!-- resources --> 
		 		<td align=right>
					Resource Hours
				</td> 
				<td> 
   					<input type="text"
							name="edit_pr_resource_hours"
							id="edit_pr_resource_hours"
							dojoType="dijit.form.NumberTextBox"
        			required="true" 
							readonly />
				</td> 
				<td> 
					<button dojoType="dijit.form.Button">
						...
						<script type="dojo/method" event="onClick">
							dijit.byId('re_alloc_dialog').show();
						</script> 
					</button>
				</td>
			</tr> 

			<tr> <!-- description (header) --> 
				<td>Project Description</td>
			</tr> 

			<tr> <!-- description (input field) --> 
       	<td colspan="3">
					<textarea id="edit_pr_desc"
						name="edit_pr_desc"
						dojoType="dijit.form.SimpleTextarea"
        		rows="4" style="width: 100%;"
						value=" ">
        	</textarea>
				</td> 
			</tr> 

			<tr>
        <td align="center" colspan="3">
          <button dojoType="dijit.form.Button" iconClass="webpmIconOk" id="edit_pr_submit" type="reset"> 
            Save
						<script type="dojo/method" event="onClick" args="evt">
							var targetBc = dijit.byId('edit_pr_business_case').attr('value'); 
							var thisPrNumber = dijit.byId ('edit_pr_number').attr ('value'); 
							var thisPrName = dijit.byId ('edit_pr_name').attr ('value'); 

							evt.stopPropagation();

							// validation 
							/* if (! dijit.byId('edit_pr_name').isValid ()) {
								; alert ('invalid edit_pr_name'); 
							} else */ if (! dijit.byId('edit_pr_number').isValid ()) {
								; alert ('invalid edit_pr_number'); 
							} /* else if (! dijit.byId('edit_pr_business_case').isValid ()) { 
								; alert ('invalid edit_pr_business_case'); 
							} else if (! dijit.byId('edit_pr_mgr').isValid ()) { 
								; alert ('invalid edit_pr_mgr'); 
							} else if (! dijit.byId('edit_pr_poc').isValid ()) { 
								; alert ('invalid edit_pr_poc'); 
							} else if (! dijit.byId('edit_pr_sponsor').isValid ()) {
								; alert ('invalid edit_pr_sponsor'); 
							} else if (! dijit.byId('edit_pr_start_date').isValid ()) { 
								; alert ('invalid edit_pr_start_date'); 
							} else if (! dijit.byId('edit_pr_end_date').isValid ()) { 
								; alert ('invalid edit_pr_end_date'); 
							} else if (! dijit.byId('edit_pr_status').isValid ()) { 
								; alert ('invalid edit_pr_status'); 
							} */ else { 

							var xhrArgs = {
								form: dojo.byId ("edit_pr_form"),
								
								url: "http://webpm:8080/webpm/projectMgr", 
								handleAs: "text",
								load: function (data) {
									alert ('thisPrNumber: ' + thisPrNumber + ' thisPrName: ' + thisPrName); 
									modifyProject (thisPrNumber, thisPrName); 
								},
								error: function(error) {
									//dojo.byId("home_container").innerHTML = "Error from server.";
								}
							};

  						var deferred = dojo.xhrPost(xhrArgs);

							//clear out the amount/resource-hours datastores ...
							project_amounts.revert (); 
							resource_allocs.revert (); 

							dijit.byId ('edit_pr_dialog').hide ();
							} 
						</script> 
          </button>
					<button dojoType="dijit.form.Button"
						iconClass="webpmIconCancel"
						onClick="dijit.byId ('edit_pr_dialog').hide (); project_amounts.revert (); resource_allocs.revert ();"
						type="reset">
						Cancel
					</button> 
        </td> 
			</tr> 

		</table> 

		</div> <!-- form --> 

	</div> 
	<!-- } --> 

	<!-- new_re_dialog { --> 
	<div dojoType="dijit.Dialog" id="new_re_dialog" title="Add Resource"> 

		<div dojoType="dijit.form.Form"
			id="new_re_form"
			jsId="new_re_form"
			encType="multipart/form-data"
			action="http://webpm:8080/webpm/resourceMgr"> 

		<table width="100%;" style="border: 1px solid #8ba0bd;padding: 0px;border-collapse: collapse;">
      <tr><td style="background-color: #8ba0bd"><b>Resource Properties:</b></td></tr>
      <tr><td>

		<table cellspacing="10" cellpadding="10">
			<tr>
		 		<td>
					Name
				</td>
				<td>
            <input type="text" dojoType="dijit.form.TextBox"
							 name="new_re_name" 
            	 id="new_re_name"
            	 value=""
            	 required="true"> 
				</td>
				<td> 
          Number: 
				</td> 
				<td> 
          	<input type="text" dojoType="dijit.form.ValidationTextBox" 
							 name="new_re_number" 
            	 id="new_re_number"
            	 regExp="re\d{4}"
            	 required="true" 
            	 invalidMessage="Invalid resource number."> 
				</td> 
			</tr> 
			<tr>
				<td>
					Project
				</td> 
				<td> 
	        	<select dojoType="dijit.form.FilteringSelect" id="new_re_project"
 	          	name="new_re_project" 
 	          	store="pr_name_store"
            	searchAttr="pr_number"> 
          	</select>
				</td> 
				<td>
					Hours
				</td>
				<td>
        	<input type="text" dojoType="dijit.form.ValidationTextBox"
            id="new_re_hours"
						name="new_re_hours" 
            regExp="\d{5}"
            required="true"
            invalidMessage="Invalid number of hours."
            style="width: 6em;">
				</td> 
			</tr> 
		</table></td></tr> 

    <tr><td style="background-color: #8ba0bd;" width="100%;"><b>Resource Description</b></td></tr>

		<tr><td> 
		<table width="100%;" cellspacing="10"> 
			<tr>
				<td>
					<textarea id="new_re_desc"
						  name="new_re_desc"
						  dojoType="dijit.form.SimpleTextarea"
        		  rows="4" style="width: 100%;"
						  value=" ">
        	</textarea>
				</td> 
			</tr> 

			<tr>
        <td align="center">
          <button dojoType="dijit.form.Button" iconClass="webpmIconOk" id="new_re_submit" type="reset"> 
            Save
						<script type="dojo/method" event="onClick" args="evt">

              evt.stopPropagation();

							// validation 
							/* if (! dijit.byId('new_re_name').isValid ()) {
								; alert ('invalid new_re_name'); 
							} else */ if (! dijit.byId('new_re_number').isValid ()) {
								; alert ('invalid new_re_number'); 
							} else { 

              var targetPr = dijit.byId('new_re_project').attr('value');
              var thisNumber = dijit.byId ('new_re_number').attr ('value');
              var thisName = dijit.byId ('new_re_name').attr ('value');
              addResource (targetPr, thisNumber, thisName);

              dijit.byId ('new_re_dialog').hide ();
              dojo.byId ('new_re_name').value = '';
              dojo.byId ('new_re_number').value = '';
              dojo.byId ('new_re_desc').value = '';

              }
						</script> 
          </button>
					<button dojoType="dijit.form.Button"
						type="reset"
						iconClass="webpmIconCancel"
						onClick="dijit.byId ('new_re_dialog').hide ();">
						Cancel
					</button> 
       </td> 
			</tr> 

		</table> 
		</table> 

	</div> <!-- form --> 

	</div>
	<!-- } --> 

	<!-- edit_re_dialog { --> 
	<div dojoType="dijit.Dialog" id="edit_re_dialog" title="Edit Resource"> 

		<div dojoType="dijit.form.Form"
			id="edit_re_form"
			jsId="edit_re_form"
			encType="multipart/form-data"
			action="http://webpm:8080/webpm/resourceMgr"> 

		<table cellspacing="10" cellpadding="10">

			<tr>
				<!-- <td style="text-align:right;">Name:</td> --> 
		 		<td>
					Name
          <input type="text" dojoType="dijit.form.TextBox"
            id="edit_re_name"
						name="edit_re_name" 
            value=""
            required="true" 
            style="width: 20em;"/> 
          Number: <!-- </td> --> 
          <input type="text" dojoType="dijit.form.ValidationTextBox" 
            id="edit_re_number"
						name="edit_re_number" 
            regExp="re\d{4}"
            required="true" 
					  readonly
            invalidMessage="Invalid resource number."> 
            <!-- style="width: 6em;"> --> 
				</td> 
			</tr> 

			<tr>
				<td>Resource Description</td>
			</tr> 

			<tr>
       	<td>
					<textarea id="edit_re_desc"
						name="edit_re_desc"
						dojoType="dijit.form.SimpleTextarea"
        		rows="4" style="width: 100%;"
						value=" ">
        	</textarea>
				</td> 
			</tr> 

			<tr>
        <td align="center">
          <button dojoType="dijit.form.Button" iconClass="webpmIconOk" id="edit_re_submit" type="reset"> 
            Save
						<script type="dojo/method" event="onClick" args="evt">
							evt.preventDefault();
							evt.stopPropagation();

							// validation 
							/* if (! dijit.byId('edit_re_name').isValid ()) {
								; alert ('invalid edit_re_name'); 
							} else */ if (! dijit.byId('edit_re_number').isValid ()) {
								; alert ('invalid edit_re_number'); 
							} else { 

							var thisReNumber = dijit.byId ('edit_re_number').attr ('value'); 
							var thisReName = dijit.byId ('edit_re_name').attr ('value'); 

							var xhrArgs = {
								form: dojo.byId ("edit_re_form"),
								
								url: "http://webpm:8080/webpm/resourceMgr", 
								handleAs: "text",
								load: function (data) {
									modifyResource (thisReNumber, thisReName); 
								},
								error: function(error) {
									//dojo.byId("home_container").innerHTML = "Error from server.";
								}
							};

  						var deferred = dojo.xhrPost(xhrArgs);

							dijit.byId ('edit_re_dialog').hide (); 

							dojo.byId ('edit_re_name').value = ''; 
							dojo.byId ('edit_re_number').value = ''; 
							dojo.byId ('edit_re_desc').value = ''; 

							} 
						</script> 
          </button>
					<button dojoType="dijit.form.Button"
						type="reset"
						iconClass="webpmIconCancel"
						onClick="dijit.byId ('edit_re_dialog').hide ();">
						Cancel
					</button> 
       </td> 
			</tr> 

		</table> 

	</div> <!-- form --> 

	</div>
	<!-- } --> 

	<!-- pr_amount_dialog { --> 
	<div dojoType="dijit.Dialog" id="pr_amount_dialog" title="Project Funding"> 

		<!-- here --> 
		<table style="border:1px solid #8ba0bd;"> 

			<tr> 
				<td> 
					Year:
          <input type="text" dojoType="dijit.form.ValidationTextBox" 
            id="pr_amount_year"
            regExp="\d{4}"
            required="true" 
            invalidMessage="Invalid year."
            style="width: 6em;"> 
					Amount: 
   				<input type="text"
						name="pr_amount_amt" id="pr_amount_amt"
						value="0.00"
						dojoType="dijit.form.CurrencyTextBox"
        		required="true"
						constraints="{fractional:true}"
						currency="USD"
						invalidMessage="Invalid amount.  Cents are required.">
					<button dojoType="dijit.form.Button">
						+ 
						<script type="dojo/method" event="onClick" args="evt">
              if (! dijit.byId('pr_amount_year').isValid ()) {
								; alert ('invalid pr_amount_year'); 
							} else if (! dijit.byId('pr_amount_amt').isValid ()) { 
								; alert ('invalid pr_amount_amt'); 
							} else if (dijit.byId ('pr_amount_amt').attr ('value') == 0) { 
								; 
							} else { 
              	/* var myNewItem = {
                	type: "year",
                	year: dijit.byId('pr_amount_year').attr('value'), 
						 	  	amount: dijit.byId('pr_amount_amt').attr('value')
              	};
								project_amounts.newItem(myNewItem); */
								project_amounts.newItem ({ 
									type: "year", 
									year: dijit.byId ('pr_amount_year').attr ('value'), 
									amount: dijit.byId ('pr_amount_amt').attr ('value') 
								}); 
							} 
             </script>	
					</button> 
				</td>
			</tr> 
		</table> 
		<!-- here --> 

		<br> 

		<table dojoType="dojox.grid.DataGrid"
			store="project_amounts"
			id="grid5" 
			query="{ year: '*' }"
			rowsPerPage="20"
   		clientSort="true"
			style="width: 100%; height: 20em; border:1px solid #8ba0bd;"
			rowSelector="15px"
			jsId="grid5">
			<thead>
        <tr>
          <th field="year">
           	Year
          </th>
          <th field="amount" editable="true" formatter="formatAmount">
           	Amount 
          </th>
       	</tr>
    	</thead>
    </table>

		<br> 

		<table width="100%" style="border:1px solid #8ba0bd;"> 

			<tr> 
				<td> 
					<button dojoType="dijit.form.Button">
						- 
						<script type="dojo/method" event="onClick" args="evt">
							var items = grid5.selection.getSelected (); 
							if (items.length) { 
								dojo.forEach (items, function (selectedItem) { 
									if (selectedItem != null)
										project_amounts.deleteItem (selectedItem); 
								} )
							};
             </script>	
					</button> 
					Remove selected amounts 
				</td>
			</tr> 
		</table> 

		<br> 

		<table width="100%" style="border:1px solid #8ba0bd;" cellspacing="7"> 
			<tr>
     		<td>
					<center> 
       		<button dojoType="dijit.form.Button" type="submit" iconClass="webpmIconOk" id="pr_amt_submit"> 
         		Save
						<script type="dojo/method" event="onClick"> 
							var targetNode = dojo.byId ("new_pr_amounts_by_year");
							var newField = "<!-- new_pr_amounts_by_year -->\n"; 
							var newTotalAmount = 0.0; 
							project_amounts.fetch ({ 
								query: {year: '*'}, 
								onItem: function (item) { 
									newField += 
										"<input type=\"hidden\" name=\"" + project_amounts.getValue(item, 'year') + "_amt" +
										"\" value=\"" + project_amounts.getValue(item, 'amount') + "\">\n"; 
									newTotalAmount += parseFloat(project_amounts.getValue(item, 'amount')); 
								}
							}); 
							dojo.byId('new_pr_amount').value = formatAmount(newTotalAmount); 
		        	targetNode.innerHTML = newField;
						</script> 
       		</button>
					<button dojoType="dijit.form.Button"
						type="submit"
						iconClass="webpmIconCancel"
						onClick="dijit.byId ('pr_amount_dialog').hide ();">
						Cancel
					</button> 
					</center> 
     		</td> 
			</tr> 

		</table> 

	</div> 
	<!-- } --> 

	<!-- re_alloc_dialog { --> 
	<div dojoType="dijit.Dialog" id="re_alloc_dialog" title="Resource-Hour Allocation"> 

		<span dojoType="dojo.data.ItemFileWriteStore" jsId="resource_allocs"
			url="json/empty_resource_allocs.json"> 

		<table style="border: 1px solid #8ba0bd;"> 
			<tr>
				<td> 
					Resource:
					<select dojoType="dijit.form.FilteringSelect" id="add_resource_alloc"
						name="add_resource_alloc" 
						store="re_name_store"
						searchAttr="re_name">
       		</select>
					Hours: 
          <input type="text" dojoType="dijit.form.ValidationTextBox" 
            id="add_resource_hours"
            regExp="\d+"
            required="true" 
            invalidMessage="Invalid number of hours."
            style="width: 6em;"> 
					<button dojoType="dijit.form.Button">
						+ 
						<script type="dojo/method" event="onClick" args="evt">
              var myNewItem = {
                type: "resource",
                resource: dijit.byId('add_resource_alloc').attr('value'), 
								hours: dijit.byId('add_resource_hours').attr('value')
              };
							if (! dijit.byId('add_resource_alloc').isValid ()) { 
								; alert ('invalid add_resource_alloc'); 
							} else if (! dijit.byId ('add_resource_hours').isValid ()) { 
								; alert ('invalid add_resource_hours'); 
							} else { 
              	resource_allocs.newItem(myNewItem);
							} 
            </script>	
					</button> 
				</td> 
			</tr> 
		</table>

		<br> 

		<table dojoType="dojox.grid.DataGrid"
			store="resource_allocs"
			query="{ resource: '*' }"
			rowsPerPage="20"
     	clientSort="true"
			style="width: 100%; height: 20em; border: 1px solid #8ba0bd;"
			rowSelector="15px"
			jsId="grid6">
			<thead>
      	<tr>
         	<th field="resource">
           	Resource
         	</th>
         	<th field="hours" editable="true">
           	Hours 
         	</th>
       	</tr>
     	</thead>
    </table>

		<br> 

		<table width="100%" style="border: 1px solid #8ba0bd;"> 
			<tr>
				<td> 
					<button dojoType="dijit.form.Button">
						- 
            <script type="dojo/method" event="onClick" args="evt">
							var items = grid6.selection.getSelected();
              if (items.length) {
                dojo.forEach(items, function(selectedItem) {
									if (selectedItem !== null) {
                		resource_allocs.deleteItem(selectedItem);
									}
                });
              } // end if
						</script> 
					</button> 
					Remove selected rows 
				</td> 
			</tr> 
		</table> 

		<br> 

		<table width="100%" style="border: 1px solid #8ba0bd" cellspacing="7">
			<form> 
			<tr>
          <td align="center">
            <button dojoType="dijit.form.Button" type="submit" iconClass="webpmIconOk" id="re_alloc_submit"> 
              Save
							<script type="dojo/method" event="onClick"> 
								var targetNode = dojo.byId ("new_pr_resource_hours_allocd");
								var newField = "<!-- new_pr_resource_hours_allocd -->\n"; 
								var newTotalHours = 0.0; 
								resource_allocs.fetch ({ 
									query: {resource: '*'}, 
									onItem: function (item) { 
										newField += 
											"<input type=\"hidden\" name=\"" + resource_allocs.getValue(item, 'resource') + "_hrs" +
											"\" value=\"" + resource_allocs.getValue(item, 'hours') + "\">\n"; 
										newTotalHours += parseFloat(resource_allocs.getValue(item, 'hours')); 
									}
								}); 
		        		targetNode.innerHTML = newField;
								dojo.byId('new_pr_resource_hours').value = parseFloat(newTotalHours); 
							</script> 
            </button>
						<button dojoType="dijit.form.Button"
							type="submit"
							iconClass="webpmIconCancel"
							onClick="dijit.byId ('re_alloc_dialog').hide ();">
							Cancel
						</button> 
          </td> 
			</tr> 
			</form> 
		</table> 
	</div> 
	<!-- } --> 

	<!-- search { --> 
	<div dojoType="dijit.Dialog" id="searchDialog" title="Search">
		<table cellspacing="10">	
			<tr>
				<td colspan="3"><b>Find records that have...</b></td>
			</tr> 
			<tr> 
				<td>
					<input type="radio" dojoType="dijit.form.RadioButton"
						name="search_criteria" id="crit_1" />
				</td>
				<td> &nbsp; all of these words:</td>
				<td>
          <input type="text" dojoType="dijit.form.TextBox" 
            id="search_criteria_1" style="width: 100%;">
				</td> 
			</tr>
			<tr>
				<td>
					<input type="radio" dojoType="dijit.form.RadioButton"
						name="search_criteria" id="crit_2" />
				</td>
				<td> &nbsp; this exact wording or phrase:</td>
				<td>
          <input type="text" dojoType="dijit.form.TextBox" 
            id="search_criteria_2" style="width: 100%;">
				</td> 
			</tr>
			<tr style="vertical-align:top;">
				<td> 
					<input type="radio" dojoType="dijit.form.RadioButton"
						name="search_criteria" id="crit_3" />
				</td>
				<td> &nbsp; one or more of these words:</td>
				<td style="align:top;">
          <input type="text" dojoType="dijit.form.TextBox" 
            id="search_criteria_3"> &nbsp; OR
				</td>
			</tr>
			<tr>
				<td></td>
				<td></td>
				<td>
          <input type="text" dojoType="dijit.form.TextBox" 
            id="search_criteria_4"> &nbsp; OR
				</td>
			</tr>
			<tr>
				<td></td>
				<td></td>
				<td>
          <input type="text" dojoType="dijit.form.TextBox" 
            id="search_criteria_5">
				</td> 
			</tr> 
			<tr>
				<td colspan="3" style="text-align:center;">
					<button dojoType="dijit.form.Button" type="submit" iconClass="webpmIconOk">
						Search 
				  	<script type="dojo/method" event="onClick">
							var newSearchResultsTab = new webpm.LoadSearchResults ().container; 
					  	dojo.mixin(newSearchResultsTab,
						 	{
								title: "Search Results", 
							 	closable: true,
							 	onClose: testClose
						 	}
							);
					  	message.addChild(newSearchResultsTab);
					  	message.selectChild(newSearchResultsTab);
						</script>
					</button> 
					<button dojoType="dijit.form.Button"
						type="submit"
						iconClass="webpmIconCancel"
						onClick="dijit.byId ('searchDialog').hide ();">
						Cancel
					</button> 
				</td>
			</tr>
		</table> 
	</div>
	<!-- } --> 

	<!-- reports { --> 
	<div dojoType="dijit.Dialog" id="reportsDialog" title="Reports">

    <table width="100%;" style="border: 1px solid #8ba0bd;padding: 0px;border-collapse: collapse;">

    <tr><td style="background-color: #8ba0bd"><b>Detailed Roadmap:</b></td></tr>

    <tr><td>
		<table cellspacing="10" cellpadding="10" align="top">	
			<tr> 
				<td>&nbsp; Business case:</td>
				<td>
					<select dojoType="dijit.form.FilteringSelect" id="detailed_roadmap_business_case"
						name="detailed_roadmap_business_case"
						store="bc_name_store" 
						searchAttr="bc_name"
						style="width: 100%;">
        	</select>
				</td> 
				<td>
					<button dojoType="dijit.form.Button"
						iconClass="webpmIconReport"
						onClick="detailed_roadmap ();">
						Report 
					</button> 
				</td> 
			</tr>
		</table>
		</td></tr>

    <tr><td style="background-color: #8ba0bd"><b>Work Initiation Plan:</b></td></tr>

		<tr><td>
		<table cellspacing="10" cellpadding="10" align="top"> 
			<tr>
				<td>
					Start date:
				</td>
				<td> 
					<input type="text"
						name="wip_start_date"
						id="wip_start_date"
						value=""
						dojoType="dijit.form.DateTextBox"
        		required="true">
				</td> 
			</tr>
			<tr>
				<td>
					End date:
				</td>
				<td>
					<input type="text"
						name="wip_end_date"
						id="wip_end_date" 
						value=""
						dojoType="dijit.form.DateTextBox"
						required="true">
				</td> 
				<td>
					&nbsp; <button dojoType="dijit.form.Button"
						iconClass="webpmIconReport"
						onClick="work_initiation_plan ();">
						Report 
					</button> 
				</td> 
			</tr> 
		</table>
		</td></tr> 

    <tr><td style="background-color: #8ba0bd"><b>Project Timeline:</b></td></tr>

		<tr><td>
		<table cellspacing="10" cellpadding="10" align="top"> 
			<tr> 
				<td> &nbsp; Business case:</td>
				<td>
					<select dojoType="dijit.form.FilteringSelect" id="project_timeline_business_case"
						name="project_timeline_business_case"
						store="bc_name_store"
						searchAttr="bc_name"
						style="width: 100%;">
        	</select>
				</td> 
				<td>
					<button dojoType="dijit.form.Button"
						iconClass="webpmIconReport"
						onClick="project_timeline ();">
						Report 
					</button> 
				</td> 
			</tr>
		</table>
		</td></tr> 

		<tr><td> 
		<table cellspacing="10" cellpadding="10" align="top" width="100%"> 
			<tr>
				<td colspan="3" style="text-align:center;">
					<button dojoType="dijit.form.Button"
						iconClass="webpmIconCancel"
						onClick="dijit.byId ('reportsDialog').hide ();">
						Dismiss
					</button> 
				</td>
			</tr>
		</table> 
		</td></tr> 

		</table> 
	</div>
	<!-- } --> 

	<!-- options { --> 
	<div dojoType="dijit.Dialog" id="optionsDialog" title="Options:">
		<table>	
			<tr>
				<td colspan="2" style="text-align:center;">
					<button dojoType="dijit.form.Button" type="submit" iconClass="webpmIconOk">Apply</button>
					<button dojoType="dijit.form.Button" type="submit" iconClass="webpmIconCancel">
						Cancel
					</button> 
				</td>
			</tr>
		</table> 
	</div>
	<!-- } --> 

	<!-- main { --> 
	<div dojoType="dijit.layout.BorderContainer" gutters="true" id="main">

		<!-- toolbar { -->
		<div dojoType="dijit.Toolbar" region="top">

			<button
				id="newMsg" dojoType="dijit.form.Button"
				iconClass="webpmIconAddBusinessCase"> 
				Add Business Case 
				<script type="dojo/method" event="onClick">
					dijit.byId('new_bc_dialog').show();
				</script> 
			</button>

			<button
				id="newProj" dojoType="dijit.form.Button"
				iconClass="webpmIconAddProject"> 
				Add Project
				<script type="dojo/method" event="onClick">
					dijit.byId('new_pr_dialog').show();
				</script> 
			</button>

			<button
				id="newRes" dojoType="dijit.form.Button"
				iconClass="webpmIconAddResource"> 
				Add Resource
				<script type="dojo/method" event="onClick">
					dijit.byId('new_re_dialog').show(); 
				</script> 
			</button>

			<button id="search" dojoType="dijit.form.Button" iconClass="webpmIconSearch"> 
				Search
				<script type="dojo/method" event="onClick"> 
					dijit.byId('searchDialog').show(); 
				</script>
 			</button>

			<button id="reports" dojoType="dijit.form.Button" iconClass="webpmIconReports"> 
				Reports
				<script type="dojo/method" event="onClick"> 
					dijit.byId('reportsDialog').show(); 
				</script> 
			</button> 

			<button id="logout" dojoType="dijit.form.Button" iconClass="webpmIconLogout"> 
				Logout
				<script type="dojo/method" event="onClick"> 
					// dijit.byId('logoutDialog').show(); 
				</script> 
			</button> 

			<!-- <button id="options" dojoType="dijit.form.Button" iconClass="webpmIconOptions"> 
			 	Options	
				<script type="dojo/method" event="onClick">
					dijit.byId('optionsDialog').show();
				</script>
			</button> --> 
			<div dojoType="dijit.Tooltip" connectId="options">Set various options</div> 
		</div> <!-- toolbar --> 
	<!-- } --> 
	
	<!-- { --> 	
	<div dojoType="dijit.layout.BorderContainer"
		id="nav"
		title="Nav Panel"
		liveSplitters="false"
		design="sidebar"
		region="center">

		<!-- accordion container { --> 
		<div dojoType="dijit.layout.AccordionContainer" id="accordionLeft"
			region="leading" style="width:20%;height:100%;" splitter="false">

			<div dojoType="dijit.layout.AccordionPane" title="Browse">

				<div id="tree">
				</div> <!-- tree --> 
				
			</div> <!-- browse pane --> 

			<!-- <div dojoType="dijit.layout.AccordionPane" title="Users">

				<div dojoType="dijit.Tree" id="cool_tree.store" 
					store="cool_tree.store"
					model="cool_tree.model" 
					label="Unassociated Projects">
				</div>  

			 	<script type="dojo/method" event="onClick" args="item">

		  	</script> 
				<script type="dojo/method" event="getIconClass" args="item">
						return (item && cool_tree.store.getValue(item, "icon")) || "webpmIconFolderObjects";
				</script>

			</div> --> <!-- admin. pane --> 

			<div dojoType="dijit.layout.AccordionPane" title="Help">

				<!-- <div dojoType="dijit.Tree" id="browse_tree_help" 
					store="cool_tree.store"
					model="cool_tree.model" 
					label="Help Topics">
				</div> --> 

			</div> <!-- help pane --> 

			</div> <!-- accordion container --> 

			<!-- } -->

			<!-- tab container { --> 
			<div id="message"
					dojoType="dijit.layout.TabContainer"
					region="center"
					tabStrip="true"
					jsId="message">
			</div>  
			<!-- } --> 

		</div>
		<!-- } -->

	</div>
	<!-- } // main -->

</body>

</html>

